/* Enums.c generated by valac 0.30.0, the Vala compiler
 * generated from Enums.vala, do not modify */

/* Enums.vala
 *
 * Copyright (C) 2009 - 2015 Jerry Casiano
 *
 * This file is part of Font Manager.
 *
 * Font Manager is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Font Manager is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Font Manager.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Author:
 *        Jerry Casiano <JerryCasiano@gmail.com>
*/

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>


#define FONT_CONFIG_TYPE_WEIGHT (font_config_weight_get_type ())

#define FONT_CONFIG_TYPE_SLANT (font_config_slant_get_type ())

#define FONT_CONFIG_TYPE_WIDTH (font_config_width_get_type ())

#define FONT_CONFIG_TYPE_SPACING (font_config_spacing_get_type ())

#define FONT_CONFIG_TYPE_SUBPIXEL_ORDER (font_config_subpixel_order_get_type ())

#define FONT_CONFIG_TYPE_HINT_STYLE (font_config_hint_style_get_type ())

#define FONT_CONFIG_TYPE_LCD_FILTER (font_config_lcd_filter_get_type ())

typedef enum  {
	FONT_CONFIG_WEIGHT_THIN = 0,
	FONT_CONFIG_WEIGHT_EXTRALIGHT = 40,
	FONT_CONFIG_WEIGHT_ULTRALIGHT = FONT_CONFIG_WEIGHT_EXTRALIGHT,
	FONT_CONFIG_WEIGHT_LIGHT = 50,
	FONT_CONFIG_WEIGHT_BOOK = 75,
	FONT_CONFIG_WEIGHT_REGULAR = 80,
	FONT_CONFIG_WEIGHT_NORMAL = FONT_CONFIG_WEIGHT_REGULAR,
	FONT_CONFIG_WEIGHT_MEDIUM = 100,
	FONT_CONFIG_WEIGHT_DEMIBOLD = 180,
	FONT_CONFIG_WEIGHT_SEMIBOLD = FONT_CONFIG_WEIGHT_DEMIBOLD,
	FONT_CONFIG_WEIGHT_BOLD = 200,
	FONT_CONFIG_WEIGHT_EXTRABOLD = 205,
	FONT_CONFIG_WEIGHT_BLACK = 210,
	FONT_CONFIG_WEIGHT_HEAVY = FONT_CONFIG_WEIGHT_BLACK,
	FONT_CONFIG_WEIGHT_EXTRABLACK = 215,
	FONT_CONFIG_WEIGHT_ULTRABLACK = FONT_CONFIG_WEIGHT_EXTRABLACK
} FontConfigWeight;

typedef enum  {
	FONT_CONFIG_SLANT_ROMAN = 0,
	FONT_CONFIG_SLANT_ITALIC = 100,
	FONT_CONFIG_SLANT_OBLIQUE = 110
} FontConfigSlant;

typedef enum  {
	FONT_CONFIG_WIDTH_ULTRACONDENSED = 50,
	FONT_CONFIG_WIDTH_EXTRACONDENSED = 63,
	FONT_CONFIG_WIDTH_CONDENSED = 75,
	FONT_CONFIG_WIDTH_SEMICONDENSED = 87,
	FONT_CONFIG_WIDTH_NORMAL = 100,
	FONT_CONFIG_WIDTH_SEMIEXPANDED = 113,
	FONT_CONFIG_WIDTH_EXPANDED = 125,
	FONT_CONFIG_WIDTH_EXTRAEXPANDED = 150,
	FONT_CONFIG_WIDTH_ULTRAEXPANDED = 200
} FontConfigWidth;

typedef enum  {
	FONT_CONFIG_SPACING_PROPORTIONAL = 0,
	FONT_CONFIG_SPACING_DUAL = 90,
	FONT_CONFIG_SPACING_MONO = 100,
	FONT_CONFIG_SPACING_CHARCELL = 110
} FontConfigSpacing;

typedef enum  {
	FONT_CONFIG_SUBPIXEL_ORDER_UNKNOWN,
	FONT_CONFIG_SUBPIXEL_ORDER_RGB,
	FONT_CONFIG_SUBPIXEL_ORDER_BGR,
	FONT_CONFIG_SUBPIXEL_ORDER_VRGB,
	FONT_CONFIG_SUBPIXEL_ORDER_VBGR,
	FONT_CONFIG_SUBPIXEL_ORDER_NONE
} FontConfigSubpixelOrder;

typedef enum  {
	FONT_CONFIG_HINT_STYLE_NONE,
	FONT_CONFIG_HINT_STYLE_SLIGHT,
	FONT_CONFIG_HINT_STYLE_MEDIUM,
	FONT_CONFIG_HINT_STYLE_FULL
} FontConfigHintStyle;

typedef enum  {
	FONT_CONFIG_LCD_FILTER_NONE,
	FONT_CONFIG_LCD_FILTER_DEFAULT,
	FONT_CONFIG_LCD_FILTER_LIGHT,
	FONT_CONFIG_LCD_FILTER_LEGACY
} FontConfigLCDFilter;



GType font_config_weight_get_type (void) G_GNUC_CONST;
gchar* font_config_weight_to_string (FontConfigWeight self);
GType font_config_slant_get_type (void) G_GNUC_CONST;
gchar* font_config_slant_to_string (FontConfigSlant self);
GType font_config_width_get_type (void) G_GNUC_CONST;
gchar* font_config_width_to_string (FontConfigWidth self);
GType font_config_spacing_get_type (void) G_GNUC_CONST;
gchar* font_config_spacing_to_string (FontConfigSpacing self);
GType font_config_subpixel_order_get_type (void) G_GNUC_CONST;
gchar* font_config_subpixel_order_to_string (FontConfigSubpixelOrder self);
GType font_config_hint_style_get_type (void) G_GNUC_CONST;
gchar* font_config_hint_style_to_string (FontConfigHintStyle self);
GType font_config_lcd_filter_get_type (void) G_GNUC_CONST;
gchar* font_config_lcd_filter_to_string (FontConfigLCDFilter self);


gchar* font_config_weight_to_string (FontConfigWeight self) {
	gchar* result = NULL;
	switch (self) {
		case FONT_CONFIG_WEIGHT_THIN:
		{
			const gchar* _tmp0_ = NULL;
			gchar* _tmp1_ = NULL;
			_tmp0_ = _ ("Thin");
			_tmp1_ = g_strdup (_tmp0_);
			result = _tmp1_;
			return result;
		}
		case FONT_CONFIG_WEIGHT_ULTRALIGHT:
		{
			const gchar* _tmp2_ = NULL;
			gchar* _tmp3_ = NULL;
			_tmp2_ = _ ("Ultra-Light");
			_tmp3_ = g_strdup (_tmp2_);
			result = _tmp3_;
			return result;
		}
		case FONT_CONFIG_WEIGHT_LIGHT:
		{
			const gchar* _tmp4_ = NULL;
			gchar* _tmp5_ = NULL;
			_tmp4_ = _ ("Light");
			_tmp5_ = g_strdup (_tmp4_);
			result = _tmp5_;
			return result;
		}
		case FONT_CONFIG_WEIGHT_BOOK:
		{
			const gchar* _tmp6_ = NULL;
			gchar* _tmp7_ = NULL;
			_tmp6_ = _ ("Book");
			_tmp7_ = g_strdup (_tmp6_);
			result = _tmp7_;
			return result;
		}
		case FONT_CONFIG_WEIGHT_MEDIUM:
		{
			const gchar* _tmp8_ = NULL;
			gchar* _tmp9_ = NULL;
			_tmp8_ = _ ("Medium");
			_tmp9_ = g_strdup (_tmp8_);
			result = _tmp9_;
			return result;
		}
		case FONT_CONFIG_WEIGHT_SEMIBOLD:
		{
			const gchar* _tmp10_ = NULL;
			gchar* _tmp11_ = NULL;
			_tmp10_ = _ ("Semi-Bold");
			_tmp11_ = g_strdup (_tmp10_);
			result = _tmp11_;
			return result;
		}
		case FONT_CONFIG_WEIGHT_BOLD:
		{
			const gchar* _tmp12_ = NULL;
			gchar* _tmp13_ = NULL;
			_tmp12_ = _ ("Bold");
			_tmp13_ = g_strdup (_tmp12_);
			result = _tmp13_;
			return result;
		}
		case FONT_CONFIG_WEIGHT_EXTRABOLD:
		{
			const gchar* _tmp14_ = NULL;
			gchar* _tmp15_ = NULL;
			_tmp14_ = _ ("Ultra-Bold");
			_tmp15_ = g_strdup (_tmp14_);
			result = _tmp15_;
			return result;
		}
		case FONT_CONFIG_WEIGHT_HEAVY:
		{
			const gchar* _tmp16_ = NULL;
			gchar* _tmp17_ = NULL;
			_tmp16_ = _ ("Heavy");
			_tmp17_ = g_strdup (_tmp16_);
			result = _tmp17_;
			return result;
		}
		case FONT_CONFIG_WEIGHT_ULTRABLACK:
		{
			const gchar* _tmp18_ = NULL;
			gchar* _tmp19_ = NULL;
			_tmp18_ = _ ("Ultra-Heavy");
			_tmp19_ = g_strdup (_tmp18_);
			result = _tmp19_;
			return result;
		}
		default:
		{
			result = NULL;
			return result;
		}
	}
}


GType font_config_weight_get_type (void) {
	static volatile gsize font_config_weight_type_id__volatile = 0;
	if (g_once_init_enter (&font_config_weight_type_id__volatile)) {
		static const GEnumValue values[] = {{FONT_CONFIG_WEIGHT_THIN, "FONT_CONFIG_WEIGHT_THIN", "thin"}, {FONT_CONFIG_WEIGHT_EXTRALIGHT, "FONT_CONFIG_WEIGHT_EXTRALIGHT", "extralight"}, {FONT_CONFIG_WEIGHT_ULTRALIGHT, "FONT_CONFIG_WEIGHT_ULTRALIGHT", "ultralight"}, {FONT_CONFIG_WEIGHT_LIGHT, "FONT_CONFIG_WEIGHT_LIGHT", "light"}, {FONT_CONFIG_WEIGHT_BOOK, "FONT_CONFIG_WEIGHT_BOOK", "book"}, {FONT_CONFIG_WEIGHT_REGULAR, "FONT_CONFIG_WEIGHT_REGULAR", "regular"}, {FONT_CONFIG_WEIGHT_NORMAL, "FONT_CONFIG_WEIGHT_NORMAL", "normal"}, {FONT_CONFIG_WEIGHT_MEDIUM, "FONT_CONFIG_WEIGHT_MEDIUM", "medium"}, {FONT_CONFIG_WEIGHT_DEMIBOLD, "FONT_CONFIG_WEIGHT_DEMIBOLD", "demibold"}, {FONT_CONFIG_WEIGHT_SEMIBOLD, "FONT_CONFIG_WEIGHT_SEMIBOLD", "semibold"}, {FONT_CONFIG_WEIGHT_BOLD, "FONT_CONFIG_WEIGHT_BOLD", "bold"}, {FONT_CONFIG_WEIGHT_EXTRABOLD, "FONT_CONFIG_WEIGHT_EXTRABOLD", "extrabold"}, {FONT_CONFIG_WEIGHT_BLACK, "FONT_CONFIG_WEIGHT_BLACK", "black"}, {FONT_CONFIG_WEIGHT_HEAVY, "FONT_CONFIG_WEIGHT_HEAVY", "heavy"}, {FONT_CONFIG_WEIGHT_EXTRABLACK, "FONT_CONFIG_WEIGHT_EXTRABLACK", "extrablack"}, {FONT_CONFIG_WEIGHT_ULTRABLACK, "FONT_CONFIG_WEIGHT_ULTRABLACK", "ultrablack"}, {0, NULL, NULL}};
		GType font_config_weight_type_id;
		font_config_weight_type_id = g_enum_register_static ("FontConfigWeight", values);
		g_once_init_leave (&font_config_weight_type_id__volatile, font_config_weight_type_id);
	}
	return font_config_weight_type_id__volatile;
}


gchar* font_config_slant_to_string (FontConfigSlant self) {
	gchar* result = NULL;
	switch (self) {
		case FONT_CONFIG_SLANT_ITALIC:
		{
			const gchar* _tmp0_ = NULL;
			gchar* _tmp1_ = NULL;
			_tmp0_ = _ ("Italic");
			_tmp1_ = g_strdup (_tmp0_);
			result = _tmp1_;
			return result;
		}
		case FONT_CONFIG_SLANT_OBLIQUE:
		{
			const gchar* _tmp2_ = NULL;
			gchar* _tmp3_ = NULL;
			_tmp2_ = _ ("Oblique");
			_tmp3_ = g_strdup (_tmp2_);
			result = _tmp3_;
			return result;
		}
		default:
		{
			result = NULL;
			return result;
		}
	}
}


GType font_config_slant_get_type (void) {
	static volatile gsize font_config_slant_type_id__volatile = 0;
	if (g_once_init_enter (&font_config_slant_type_id__volatile)) {
		static const GEnumValue values[] = {{FONT_CONFIG_SLANT_ROMAN, "FONT_CONFIG_SLANT_ROMAN", "roman"}, {FONT_CONFIG_SLANT_ITALIC, "FONT_CONFIG_SLANT_ITALIC", "italic"}, {FONT_CONFIG_SLANT_OBLIQUE, "FONT_CONFIG_SLANT_OBLIQUE", "oblique"}, {0, NULL, NULL}};
		GType font_config_slant_type_id;
		font_config_slant_type_id = g_enum_register_static ("FontConfigSlant", values);
		g_once_init_leave (&font_config_slant_type_id__volatile, font_config_slant_type_id);
	}
	return font_config_slant_type_id__volatile;
}


gchar* font_config_width_to_string (FontConfigWidth self) {
	gchar* result = NULL;
	switch (self) {
		case FONT_CONFIG_WIDTH_ULTRACONDENSED:
		{
			const gchar* _tmp0_ = NULL;
			gchar* _tmp1_ = NULL;
			_tmp0_ = _ ("Ultra-Condensed");
			_tmp1_ = g_strdup (_tmp0_);
			result = _tmp1_;
			return result;
		}
		case FONT_CONFIG_WIDTH_EXTRACONDENSED:
		{
			const gchar* _tmp2_ = NULL;
			gchar* _tmp3_ = NULL;
			_tmp2_ = _ ("Extra-Condensed");
			_tmp3_ = g_strdup (_tmp2_);
			result = _tmp3_;
			return result;
		}
		case FONT_CONFIG_WIDTH_CONDENSED:
		{
			const gchar* _tmp4_ = NULL;
			gchar* _tmp5_ = NULL;
			_tmp4_ = _ ("Condensed");
			_tmp5_ = g_strdup (_tmp4_);
			result = _tmp5_;
			return result;
		}
		case FONT_CONFIG_WIDTH_SEMICONDENSED:
		{
			const gchar* _tmp6_ = NULL;
			gchar* _tmp7_ = NULL;
			_tmp6_ = _ ("Semi-Condensed");
			_tmp7_ = g_strdup (_tmp6_);
			result = _tmp7_;
			return result;
		}
		case FONT_CONFIG_WIDTH_SEMIEXPANDED:
		{
			const gchar* _tmp8_ = NULL;
			gchar* _tmp9_ = NULL;
			_tmp8_ = _ ("Semi-Expanded");
			_tmp9_ = g_strdup (_tmp8_);
			result = _tmp9_;
			return result;
		}
		case FONT_CONFIG_WIDTH_EXPANDED:
		{
			const gchar* _tmp10_ = NULL;
			gchar* _tmp11_ = NULL;
			_tmp10_ = _ ("Expanded");
			_tmp11_ = g_strdup (_tmp10_);
			result = _tmp11_;
			return result;
		}
		case FONT_CONFIG_WIDTH_EXTRAEXPANDED:
		{
			const gchar* _tmp12_ = NULL;
			gchar* _tmp13_ = NULL;
			_tmp12_ = _ ("Extra-Expanded");
			_tmp13_ = g_strdup (_tmp12_);
			result = _tmp13_;
			return result;
		}
		case FONT_CONFIG_WIDTH_ULTRAEXPANDED:
		{
			const gchar* _tmp14_ = NULL;
			gchar* _tmp15_ = NULL;
			_tmp14_ = _ ("Ultra-Expanded");
			_tmp15_ = g_strdup (_tmp14_);
			result = _tmp15_;
			return result;
		}
		default:
		{
			result = NULL;
			return result;
		}
	}
}


GType font_config_width_get_type (void) {
	static volatile gsize font_config_width_type_id__volatile = 0;
	if (g_once_init_enter (&font_config_width_type_id__volatile)) {
		static const GEnumValue values[] = {{FONT_CONFIG_WIDTH_ULTRACONDENSED, "FONT_CONFIG_WIDTH_ULTRACONDENSED", "ultracondensed"}, {FONT_CONFIG_WIDTH_EXTRACONDENSED, "FONT_CONFIG_WIDTH_EXTRACONDENSED", "extracondensed"}, {FONT_CONFIG_WIDTH_CONDENSED, "FONT_CONFIG_WIDTH_CONDENSED", "condensed"}, {FONT_CONFIG_WIDTH_SEMICONDENSED, "FONT_CONFIG_WIDTH_SEMICONDENSED", "semicondensed"}, {FONT_CONFIG_WIDTH_NORMAL, "FONT_CONFIG_WIDTH_NORMAL", "normal"}, {FONT_CONFIG_WIDTH_SEMIEXPANDED, "FONT_CONFIG_WIDTH_SEMIEXPANDED", "semiexpanded"}, {FONT_CONFIG_WIDTH_EXPANDED, "FONT_CONFIG_WIDTH_EXPANDED", "expanded"}, {FONT_CONFIG_WIDTH_EXTRAEXPANDED, "FONT_CONFIG_WIDTH_EXTRAEXPANDED", "extraexpanded"}, {FONT_CONFIG_WIDTH_ULTRAEXPANDED, "FONT_CONFIG_WIDTH_ULTRAEXPANDED", "ultraexpanded"}, {0, NULL, NULL}};
		GType font_config_width_type_id;
		font_config_width_type_id = g_enum_register_static ("FontConfigWidth", values);
		g_once_init_leave (&font_config_width_type_id__volatile, font_config_width_type_id);
	}
	return font_config_width_type_id__volatile;
}


gchar* font_config_spacing_to_string (FontConfigSpacing self) {
	gchar* result = NULL;
	switch (self) {
		case FONT_CONFIG_SPACING_PROPORTIONAL:
		{
			const gchar* _tmp0_ = NULL;
			gchar* _tmp1_ = NULL;
			_tmp0_ = _ ("Proportional");
			_tmp1_ = g_strdup (_tmp0_);
			result = _tmp1_;
			return result;
		}
		case FONT_CONFIG_SPACING_DUAL:
		{
			const gchar* _tmp2_ = NULL;
			gchar* _tmp3_ = NULL;
			_tmp2_ = _ ("Dual Width");
			_tmp3_ = g_strdup (_tmp2_);
			result = _tmp3_;
			return result;
		}
		case FONT_CONFIG_SPACING_MONO:
		{
			const gchar* _tmp4_ = NULL;
			gchar* _tmp5_ = NULL;
			_tmp4_ = _ ("Monospace");
			_tmp5_ = g_strdup (_tmp4_);
			result = _tmp5_;
			return result;
		}
		case FONT_CONFIG_SPACING_CHARCELL:
		{
			const gchar* _tmp6_ = NULL;
			gchar* _tmp7_ = NULL;
			_tmp6_ = _ ("Charcell");
			_tmp7_ = g_strdup (_tmp6_);
			result = _tmp7_;
			return result;
		}
		default:
		{
			result = NULL;
			return result;
		}
	}
}


GType font_config_spacing_get_type (void) {
	static volatile gsize font_config_spacing_type_id__volatile = 0;
	if (g_once_init_enter (&font_config_spacing_type_id__volatile)) {
		static const GEnumValue values[] = {{FONT_CONFIG_SPACING_PROPORTIONAL, "FONT_CONFIG_SPACING_PROPORTIONAL", "proportional"}, {FONT_CONFIG_SPACING_DUAL, "FONT_CONFIG_SPACING_DUAL", "dual"}, {FONT_CONFIG_SPACING_MONO, "FONT_CONFIG_SPACING_MONO", "mono"}, {FONT_CONFIG_SPACING_CHARCELL, "FONT_CONFIG_SPACING_CHARCELL", "charcell"}, {0, NULL, NULL}};
		GType font_config_spacing_type_id;
		font_config_spacing_type_id = g_enum_register_static ("FontConfigSpacing", values);
		g_once_init_leave (&font_config_spacing_type_id__volatile, font_config_spacing_type_id);
	}
	return font_config_spacing_type_id__volatile;
}


gchar* font_config_subpixel_order_to_string (FontConfigSubpixelOrder self) {
	gchar* result = NULL;
	switch (self) {
		case FONT_CONFIG_SUBPIXEL_ORDER_UNKNOWN:
		{
			const gchar* _tmp0_ = NULL;
			gchar* _tmp1_ = NULL;
			_tmp0_ = _ ("Unknown");
			_tmp1_ = g_strdup (_tmp0_);
			result = _tmp1_;
			return result;
		}
		case FONT_CONFIG_SUBPIXEL_ORDER_RGB:
		{
			const gchar* _tmp2_ = NULL;
			gchar* _tmp3_ = NULL;
			_tmp2_ = _ ("RGB");
			_tmp3_ = g_strdup (_tmp2_);
			result = _tmp3_;
			return result;
		}
		case FONT_CONFIG_SUBPIXEL_ORDER_BGR:
		{
			const gchar* _tmp4_ = NULL;
			gchar* _tmp5_ = NULL;
			_tmp4_ = _ ("BGR");
			_tmp5_ = g_strdup (_tmp4_);
			result = _tmp5_;
			return result;
		}
		case FONT_CONFIG_SUBPIXEL_ORDER_VRGB:
		{
			const gchar* _tmp6_ = NULL;
			gchar* _tmp7_ = NULL;
			_tmp6_ = _ ("VRGB");
			_tmp7_ = g_strdup (_tmp6_);
			result = _tmp7_;
			return result;
		}
		case FONT_CONFIG_SUBPIXEL_ORDER_VBGR:
		{
			const gchar* _tmp8_ = NULL;
			gchar* _tmp9_ = NULL;
			_tmp8_ = _ ("VBGR");
			_tmp9_ = g_strdup (_tmp8_);
			result = _tmp9_;
			return result;
		}
		default:
		{
			const gchar* _tmp10_ = NULL;
			gchar* _tmp11_ = NULL;
			_tmp10_ = _ ("None");
			_tmp11_ = g_strdup (_tmp10_);
			result = _tmp11_;
			return result;
		}
	}
}


GType font_config_subpixel_order_get_type (void) {
	static volatile gsize font_config_subpixel_order_type_id__volatile = 0;
	if (g_once_init_enter (&font_config_subpixel_order_type_id__volatile)) {
		static const GEnumValue values[] = {{FONT_CONFIG_SUBPIXEL_ORDER_UNKNOWN, "FONT_CONFIG_SUBPIXEL_ORDER_UNKNOWN", "unknown"}, {FONT_CONFIG_SUBPIXEL_ORDER_RGB, "FONT_CONFIG_SUBPIXEL_ORDER_RGB", "rgb"}, {FONT_CONFIG_SUBPIXEL_ORDER_BGR, "FONT_CONFIG_SUBPIXEL_ORDER_BGR", "bgr"}, {FONT_CONFIG_SUBPIXEL_ORDER_VRGB, "FONT_CONFIG_SUBPIXEL_ORDER_VRGB", "vrgb"}, {FONT_CONFIG_SUBPIXEL_ORDER_VBGR, "FONT_CONFIG_SUBPIXEL_ORDER_VBGR", "vbgr"}, {FONT_CONFIG_SUBPIXEL_ORDER_NONE, "FONT_CONFIG_SUBPIXEL_ORDER_NONE", "none"}, {0, NULL, NULL}};
		GType font_config_subpixel_order_type_id;
		font_config_subpixel_order_type_id = g_enum_register_static ("FontConfigSubpixelOrder", values);
		g_once_init_leave (&font_config_subpixel_order_type_id__volatile, font_config_subpixel_order_type_id);
	}
	return font_config_subpixel_order_type_id__volatile;
}


gchar* font_config_hint_style_to_string (FontConfigHintStyle self) {
	gchar* result = NULL;
	switch (self) {
		case FONT_CONFIG_HINT_STYLE_SLIGHT:
		{
			const gchar* _tmp0_ = NULL;
			gchar* _tmp1_ = NULL;
			_tmp0_ = _ ("Slight");
			_tmp1_ = g_strdup (_tmp0_);
			result = _tmp1_;
			return result;
		}
		case FONT_CONFIG_HINT_STYLE_MEDIUM:
		{
			const gchar* _tmp2_ = NULL;
			gchar* _tmp3_ = NULL;
			_tmp2_ = _ ("Medium");
			_tmp3_ = g_strdup (_tmp2_);
			result = _tmp3_;
			return result;
		}
		case FONT_CONFIG_HINT_STYLE_FULL:
		{
			const gchar* _tmp4_ = NULL;
			gchar* _tmp5_ = NULL;
			_tmp4_ = _ ("Full");
			_tmp5_ = g_strdup (_tmp4_);
			result = _tmp5_;
			return result;
		}
		default:
		{
			const gchar* _tmp6_ = NULL;
			gchar* _tmp7_ = NULL;
			_tmp6_ = _ ("None");
			_tmp7_ = g_strdup (_tmp6_);
			result = _tmp7_;
			return result;
		}
	}
}


GType font_config_hint_style_get_type (void) {
	static volatile gsize font_config_hint_style_type_id__volatile = 0;
	if (g_once_init_enter (&font_config_hint_style_type_id__volatile)) {
		static const GEnumValue values[] = {{FONT_CONFIG_HINT_STYLE_NONE, "FONT_CONFIG_HINT_STYLE_NONE", "none"}, {FONT_CONFIG_HINT_STYLE_SLIGHT, "FONT_CONFIG_HINT_STYLE_SLIGHT", "slight"}, {FONT_CONFIG_HINT_STYLE_MEDIUM, "FONT_CONFIG_HINT_STYLE_MEDIUM", "medium"}, {FONT_CONFIG_HINT_STYLE_FULL, "FONT_CONFIG_HINT_STYLE_FULL", "full"}, {0, NULL, NULL}};
		GType font_config_hint_style_type_id;
		font_config_hint_style_type_id = g_enum_register_static ("FontConfigHintStyle", values);
		g_once_init_leave (&font_config_hint_style_type_id__volatile, font_config_hint_style_type_id);
	}
	return font_config_hint_style_type_id__volatile;
}


gchar* font_config_lcd_filter_to_string (FontConfigLCDFilter self) {
	gchar* result = NULL;
	switch (self) {
		case FONT_CONFIG_LCD_FILTER_DEFAULT:
		{
			const gchar* _tmp0_ = NULL;
			gchar* _tmp1_ = NULL;
			_tmp0_ = _ ("Default");
			_tmp1_ = g_strdup (_tmp0_);
			result = _tmp1_;
			return result;
		}
		case FONT_CONFIG_LCD_FILTER_LIGHT:
		{
			const gchar* _tmp2_ = NULL;
			gchar* _tmp3_ = NULL;
			_tmp2_ = _ ("Light");
			_tmp3_ = g_strdup (_tmp2_);
			result = _tmp3_;
			return result;
		}
		case FONT_CONFIG_LCD_FILTER_LEGACY:
		{
			const gchar* _tmp4_ = NULL;
			gchar* _tmp5_ = NULL;
			_tmp4_ = _ ("Legacy");
			_tmp5_ = g_strdup (_tmp4_);
			result = _tmp5_;
			return result;
		}
		default:
		{
			const gchar* _tmp6_ = NULL;
			gchar* _tmp7_ = NULL;
			_tmp6_ = _ ("None");
			_tmp7_ = g_strdup (_tmp6_);
			result = _tmp7_;
			return result;
		}
	}
}


GType font_config_lcd_filter_get_type (void) {
	static volatile gsize font_config_lcd_filter_type_id__volatile = 0;
	if (g_once_init_enter (&font_config_lcd_filter_type_id__volatile)) {
		static const GEnumValue values[] = {{FONT_CONFIG_LCD_FILTER_NONE, "FONT_CONFIG_LCD_FILTER_NONE", "none"}, {FONT_CONFIG_LCD_FILTER_DEFAULT, "FONT_CONFIG_LCD_FILTER_DEFAULT", "default"}, {FONT_CONFIG_LCD_FILTER_LIGHT, "FONT_CONFIG_LCD_FILTER_LIGHT", "light"}, {FONT_CONFIG_LCD_FILTER_LEGACY, "FONT_CONFIG_LCD_FILTER_LEGACY", "legacy"}, {0, NULL, NULL}};
		GType font_config_lcd_filter_type_id;
		font_config_lcd_filter_type_id = g_enum_register_static ("FontConfigLCDFilter", values);
		g_once_init_leave (&font_config_lcd_filter_type_id__volatile, font_config_lcd_filter_type_id);
	}
	return font_config_lcd_filter_type_id__volatile;
}



