/* Font.c generated by valac 0.30.0, the Vala compiler
 * generated from Font.vala, do not modify */

/* Font.vala
 *
 * Copyright (C) 2009 - 2015 Jerry Casiano
 *
 * This file is part of Font Manager.
 *
 * Font Manager is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Font Manager is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Font Manager.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Author:
 *        Jerry Casiano <JerryCasiano@gmail.com>
*/

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <json-glib/json-glib.h>
#include <json-glib/json-gobject.h>


#define TYPE_CACHEABLE (cacheable_get_type ())
#define CACHEABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CACHEABLE, Cacheable))
#define CACHEABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CACHEABLE, CacheableClass))
#define IS_CACHEABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CACHEABLE))
#define IS_CACHEABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CACHEABLE))
#define CACHEABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CACHEABLE, CacheableClass))

typedef struct _Cacheable Cacheable;
typedef struct _CacheableClass CacheableClass;

#define FONT_CONFIG_TYPE_FONT (font_config_font_get_type ())
#define FONT_CONFIG_FONT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FONT_CONFIG_TYPE_FONT, FontConfigFont))
#define FONT_CONFIG_FONT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FONT_CONFIG_TYPE_FONT, FontConfigFontClass))
#define FONT_CONFIG_IS_FONT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FONT_CONFIG_TYPE_FONT))
#define FONT_CONFIG_IS_FONT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FONT_CONFIG_TYPE_FONT))
#define FONT_CONFIG_FONT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FONT_CONFIG_TYPE_FONT, FontConfigFontClass))

typedef struct _FontConfigFont FontConfigFont;
typedef struct _FontConfigFontClass FontConfigFontClass;
typedef struct _CacheablePrivate CacheablePrivate;
typedef struct _FontConfigFontPrivate FontConfigFontPrivate;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

#define FONT_CONFIG_TYPE_WEIGHT (font_config_weight_get_type ())

#define FONT_CONFIG_TYPE_SLANT (font_config_slant_get_type ())

#define FONT_CONFIG_TYPE_WIDTH (font_config_width_get_type ())
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))

struct _Cacheable {
	GObject parent_instance;
	CacheablePrivate * priv;
};

struct _CacheableClass {
	GObjectClass parent_class;
	gboolean (*deserialize_property) (Cacheable* self, const gchar* prop_name, GValue* val, GParamSpec* pspec, JsonNode* node);
	JsonNode* (*serialize_property) (Cacheable* self, const gchar* prop_name, GValue* val, GParamSpec* pspec);
};

struct _FontConfigFont {
	Cacheable parent_instance;
	FontConfigFontPrivate * priv;
};

struct _FontConfigFontClass {
	CacheableClass parent_class;
};

struct _FontConfigFontPrivate {
	gchar* _filepath;
	gint _index;
	gchar* _family;
	gchar* _style;
	gint _slant;
	gint _weight;
	gint _width;
	gint _spacing;
	gint _owner;
	gchar* _description;
};

typedef enum  {
	FONT_CONFIG_WEIGHT_THIN = 0,
	FONT_CONFIG_WEIGHT_EXTRALIGHT = 40,
	FONT_CONFIG_WEIGHT_ULTRALIGHT = FONT_CONFIG_WEIGHT_EXTRALIGHT,
	FONT_CONFIG_WEIGHT_LIGHT = 50,
	FONT_CONFIG_WEIGHT_BOOK = 75,
	FONT_CONFIG_WEIGHT_REGULAR = 80,
	FONT_CONFIG_WEIGHT_NORMAL = FONT_CONFIG_WEIGHT_REGULAR,
	FONT_CONFIG_WEIGHT_MEDIUM = 100,
	FONT_CONFIG_WEIGHT_DEMIBOLD = 180,
	FONT_CONFIG_WEIGHT_SEMIBOLD = FONT_CONFIG_WEIGHT_DEMIBOLD,
	FONT_CONFIG_WEIGHT_BOLD = 200,
	FONT_CONFIG_WEIGHT_EXTRABOLD = 205,
	FONT_CONFIG_WEIGHT_BLACK = 210,
	FONT_CONFIG_WEIGHT_HEAVY = FONT_CONFIG_WEIGHT_BLACK,
	FONT_CONFIG_WEIGHT_EXTRABLACK = 215,
	FONT_CONFIG_WEIGHT_ULTRABLACK = FONT_CONFIG_WEIGHT_EXTRABLACK
} FontConfigWeight;

typedef enum  {
	FONT_CONFIG_SLANT_ROMAN = 0,
	FONT_CONFIG_SLANT_ITALIC = 100,
	FONT_CONFIG_SLANT_OBLIQUE = 110
} FontConfigSlant;

typedef enum  {
	FONT_CONFIG_WIDTH_ULTRACONDENSED = 50,
	FONT_CONFIG_WIDTH_EXTRACONDENSED = 63,
	FONT_CONFIG_WIDTH_CONDENSED = 75,
	FONT_CONFIG_WIDTH_SEMICONDENSED = 87,
	FONT_CONFIG_WIDTH_NORMAL = 100,
	FONT_CONFIG_WIDTH_SEMIEXPANDED = 113,
	FONT_CONFIG_WIDTH_EXPANDED = 125,
	FONT_CONFIG_WIDTH_EXTRAEXPANDED = 150,
	FONT_CONFIG_WIDTH_ULTRAEXPANDED = 200
} FontConfigWidth;


static gpointer font_config_font_parent_class = NULL;

GType cacheable_get_type (void) G_GNUC_CONST;
GType font_config_font_get_type (void) G_GNUC_CONST;
gint font_config_sort_fonts (FontConfigFont* a, FontConfigFont* b);
gint font_config_font_get_weight (FontConfigFont* self);
gint font_config_font_get_slant (FontConfigFont* self);
gint font_config_font_get_width (FontConfigFont* self);
const gchar* font_config_font_get_style (FontConfigFont* self);
gint natural_cmp (const gchar* a, const gchar* b);
#define FONT_CONFIG_FONT_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), FONT_CONFIG_TYPE_FONT, FontConfigFontPrivate))
enum  {
	FONT_CONFIG_FONT_DUMMY_PROPERTY,
	FONT_CONFIG_FONT_FILEPATH,
	FONT_CONFIG_FONT_INDEX,
	FONT_CONFIG_FONT_FAMILY,
	FONT_CONFIG_FONT_STYLE,
	FONT_CONFIG_FONT_SLANT,
	FONT_CONFIG_FONT_WEIGHT,
	FONT_CONFIG_FONT_WIDTH,
	FONT_CONFIG_FONT_SPACING,
	FONT_CONFIG_FONT_OWNER,
	FONT_CONFIG_FONT_DESCRIPTION
};
gchar* font_config_font_to_filename (FontConfigFont* self);
gchar* font_config_font_to_string (FontConfigFont* self);
const gchar* font_config_font_get_family (FontConfigFont* self);
void builder_append (GString* builder, const gchar* val);
GType font_config_weight_get_type (void) G_GNUC_CONST;
gchar* font_config_weight_to_string (FontConfigWeight self);
GType font_config_slant_get_type (void) G_GNUC_CONST;
gchar* font_config_slant_to_string (FontConfigSlant self);
GType font_config_width_get_type (void) G_GNUC_CONST;
gchar* font_config_width_to_string (FontConfigWidth self);
FontConfigFont* font_config_font_new (void);
FontConfigFont* font_config_font_construct (GType object_type);
Cacheable* cacheable_new (void);
Cacheable* cacheable_construct (GType object_type);
const gchar* font_config_font_get_filepath (FontConfigFont* self);
void font_config_font_set_filepath (FontConfigFont* self, const gchar* value);
gint font_config_font_get_index (FontConfigFont* self);
void font_config_font_set_index (FontConfigFont* self, gint value);
void font_config_font_set_family (FontConfigFont* self, const gchar* value);
void font_config_font_set_style (FontConfigFont* self, const gchar* value);
void font_config_font_set_slant (FontConfigFont* self, gint value);
void font_config_font_set_weight (FontConfigFont* self, gint value);
void font_config_font_set_width (FontConfigFont* self, gint value);
gint font_config_font_get_spacing (FontConfigFont* self);
void font_config_font_set_spacing (FontConfigFont* self, gint value);
gint font_config_font_get_owner (FontConfigFont* self);
void font_config_font_set_owner (FontConfigFont* self, gint value);
const gchar* font_config_font_get_description (FontConfigFont* self);
void font_config_font_set_description (FontConfigFont* self, const gchar* value);
static void font_config_font_finalize (GObject* obj);
static void _vala_font_config_font_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_font_config_font_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


gint font_config_sort_fonts (FontConfigFont* a, FontConfigFont* b) {
	gint result = 0;
	FontConfigFont* _tmp0_ = NULL;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	FontConfigFont* _tmp3_ = NULL;
	gint _tmp4_ = 0;
	gint _tmp5_ = 0;
	g_return_val_if_fail (a != NULL, 0);
	g_return_val_if_fail (b != NULL, 0);
	_tmp0_ = a;
	_tmp1_ = font_config_font_get_weight (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = b;
	_tmp4_ = font_config_font_get_weight (_tmp3_);
	_tmp5_ = _tmp4_;
	if (_tmp2_ != _tmp5_) {
		FontConfigFont* _tmp6_ = NULL;
		gint _tmp7_ = 0;
		gint _tmp8_ = 0;
		FontConfigFont* _tmp9_ = NULL;
		gint _tmp10_ = 0;
		gint _tmp11_ = 0;
		_tmp6_ = a;
		_tmp7_ = font_config_font_get_weight (_tmp6_);
		_tmp8_ = _tmp7_;
		_tmp9_ = b;
		_tmp10_ = font_config_font_get_weight (_tmp9_);
		_tmp11_ = _tmp10_;
		result = _tmp8_ - _tmp11_;
		return result;
	} else {
		FontConfigFont* _tmp12_ = NULL;
		gint _tmp13_ = 0;
		gint _tmp14_ = 0;
		FontConfigFont* _tmp15_ = NULL;
		gint _tmp16_ = 0;
		gint _tmp17_ = 0;
		_tmp12_ = a;
		_tmp13_ = font_config_font_get_slant (_tmp12_);
		_tmp14_ = _tmp13_;
		_tmp15_ = b;
		_tmp16_ = font_config_font_get_slant (_tmp15_);
		_tmp17_ = _tmp16_;
		if (_tmp14_ != _tmp17_) {
			FontConfigFont* _tmp18_ = NULL;
			gint _tmp19_ = 0;
			gint _tmp20_ = 0;
			FontConfigFont* _tmp21_ = NULL;
			gint _tmp22_ = 0;
			gint _tmp23_ = 0;
			_tmp18_ = a;
			_tmp19_ = font_config_font_get_slant (_tmp18_);
			_tmp20_ = _tmp19_;
			_tmp21_ = b;
			_tmp22_ = font_config_font_get_slant (_tmp21_);
			_tmp23_ = _tmp22_;
			result = _tmp20_ - _tmp23_;
			return result;
		} else {
			FontConfigFont* _tmp24_ = NULL;
			gint _tmp25_ = 0;
			gint _tmp26_ = 0;
			FontConfigFont* _tmp27_ = NULL;
			gint _tmp28_ = 0;
			gint _tmp29_ = 0;
			_tmp24_ = a;
			_tmp25_ = font_config_font_get_width (_tmp24_);
			_tmp26_ = _tmp25_;
			_tmp27_ = b;
			_tmp28_ = font_config_font_get_width (_tmp27_);
			_tmp29_ = _tmp28_;
			if (_tmp26_ != _tmp29_) {
				FontConfigFont* _tmp30_ = NULL;
				gint _tmp31_ = 0;
				gint _tmp32_ = 0;
				FontConfigFont* _tmp33_ = NULL;
				gint _tmp34_ = 0;
				gint _tmp35_ = 0;
				_tmp30_ = a;
				_tmp31_ = font_config_font_get_width (_tmp30_);
				_tmp32_ = _tmp31_;
				_tmp33_ = b;
				_tmp34_ = font_config_font_get_width (_tmp33_);
				_tmp35_ = _tmp34_;
				result = _tmp32_ - _tmp35_;
				return result;
			} else {
				FontConfigFont* _tmp36_ = NULL;
				const gchar* _tmp37_ = NULL;
				const gchar* _tmp38_ = NULL;
				FontConfigFont* _tmp39_ = NULL;
				const gchar* _tmp40_ = NULL;
				const gchar* _tmp41_ = NULL;
				_tmp36_ = a;
				_tmp37_ = font_config_font_get_style (_tmp36_);
				_tmp38_ = _tmp37_;
				_tmp39_ = b;
				_tmp40_ = font_config_font_get_style (_tmp39_);
				_tmp41_ = _tmp40_;
				if (g_strcmp0 (_tmp38_, _tmp41_) != 0) {
					FontConfigFont* _tmp42_ = NULL;
					const gchar* _tmp43_ = NULL;
					const gchar* _tmp44_ = NULL;
					FontConfigFont* _tmp45_ = NULL;
					const gchar* _tmp46_ = NULL;
					const gchar* _tmp47_ = NULL;
					gint _tmp48_ = 0;
					_tmp42_ = a;
					_tmp43_ = font_config_font_get_style (_tmp42_);
					_tmp44_ = _tmp43_;
					_tmp45_ = b;
					_tmp46_ = font_config_font_get_style (_tmp45_);
					_tmp47_ = _tmp46_;
					_tmp48_ = natural_cmp (_tmp44_, _tmp47_);
					result = _tmp48_;
					return result;
				} else {
					result = 0;
					return result;
				}
			}
		}
	}
}


static gchar* string_replace (const gchar* self, const gchar* old, const gchar* replacement) {
	gchar* result = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (old != NULL, NULL);
	g_return_val_if_fail (replacement != NULL, NULL);
	{
		GRegex* regex = NULL;
		const gchar* _tmp0_ = NULL;
		gchar* _tmp1_ = NULL;
		gchar* _tmp2_ = NULL;
		GRegex* _tmp3_ = NULL;
		GRegex* _tmp4_ = NULL;
		gchar* _tmp5_ = NULL;
		GRegex* _tmp6_ = NULL;
		const gchar* _tmp7_ = NULL;
		gchar* _tmp8_ = NULL;
		gchar* _tmp9_ = NULL;
		_tmp0_ = old;
		_tmp1_ = g_regex_escape_string (_tmp0_, -1);
		_tmp2_ = _tmp1_;
		_tmp3_ = g_regex_new (_tmp2_, 0, 0, &_inner_error_);
		_tmp4_ = _tmp3_;
		_g_free0 (_tmp2_);
		regex = _tmp4_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			if (_inner_error_->domain == G_REGEX_ERROR) {
				goto __catch37_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		_tmp6_ = regex;
		_tmp7_ = replacement;
		_tmp8_ = g_regex_replace_literal (_tmp6_, self, (gssize) -1, 0, _tmp7_, 0, &_inner_error_);
		_tmp5_ = _tmp8_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			_g_regex_unref0 (regex);
			if (_inner_error_->domain == G_REGEX_ERROR) {
				goto __catch37_g_regex_error;
			}
			_g_regex_unref0 (regex);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		_tmp9_ = _tmp5_;
		_tmp5_ = NULL;
		result = _tmp9_;
		_g_free0 (_tmp5_);
		_g_regex_unref0 (regex);
		return result;
	}
	goto __finally37;
	__catch37_g_regex_error:
	{
		GError* e = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		g_assert_not_reached ();
		_g_error_free0 (e);
	}
	__finally37:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
}


gchar* font_config_font_to_filename (FontConfigFont* self) {
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	gchar* _tmp5_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = font_config_font_to_string (self);
	_tmp1_ = _tmp0_;
	_tmp2_ = string_replace (_tmp1_, " ", "_");
	_tmp3_ = _tmp2_;
	_tmp4_ = string_replace (_tmp3_, "-", "_");
	_tmp5_ = _tmp4_;
	_g_free0 (_tmp3_);
	_g_free0 (_tmp1_);
	result = _tmp5_;
	return result;
}


static gchar* string_strip (const gchar* self) {
	gchar* result = NULL;
	gchar* _result_ = NULL;
	gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_strdup (self);
	_result_ = _tmp0_;
	_tmp1_ = _result_;
	g_strstrip (_tmp1_);
	result = _result_;
	return result;
}


gchar* font_config_font_to_string (FontConfigFont* self) {
	gchar* result = NULL;
	GString* builder = NULL;
	const gchar* _tmp0_ = NULL;
	GString* _tmp1_ = NULL;
	GString* _tmp2_ = NULL;
	gint _tmp3_ = 0;
	gchar* _tmp4_ = NULL;
	gchar* _tmp5_ = NULL;
	GString* _tmp6_ = NULL;
	gint _tmp7_ = 0;
	gchar* _tmp8_ = NULL;
	gchar* _tmp9_ = NULL;
	GString* _tmp10_ = NULL;
	gint _tmp11_ = 0;
	gchar* _tmp12_ = NULL;
	gchar* _tmp13_ = NULL;
	gchar* _result_ = NULL;
	GString* _tmp14_ = NULL;
	const gchar* _tmp15_ = NULL;
	gchar* _tmp16_ = NULL;
	const gchar* _tmp17_ = NULL;
	const gchar* _tmp18_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_family;
	_tmp1_ = g_string_new (_tmp0_);
	builder = _tmp1_;
	_tmp2_ = builder;
	_tmp3_ = self->priv->_weight;
	_tmp4_ = font_config_weight_to_string ((FontConfigWeight) _tmp3_);
	_tmp5_ = _tmp4_;
	builder_append (_tmp2_, _tmp5_);
	_g_free0 (_tmp5_);
	_tmp6_ = builder;
	_tmp7_ = self->priv->_slant;
	_tmp8_ = font_config_slant_to_string ((FontConfigSlant) _tmp7_);
	_tmp9_ = _tmp8_;
	builder_append (_tmp6_, _tmp9_);
	_g_free0 (_tmp9_);
	_tmp10_ = builder;
	_tmp11_ = self->priv->_width;
	_tmp12_ = font_config_width_to_string ((FontConfigWidth) _tmp11_);
	_tmp13_ = _tmp12_;
	builder_append (_tmp10_, _tmp13_);
	_g_free0 (_tmp13_);
	_tmp14_ = builder;
	_tmp15_ = _tmp14_->str;
	_tmp16_ = string_strip (_tmp15_);
	_result_ = _tmp16_;
	_tmp17_ = _result_;
	_tmp18_ = self->priv->_family;
	if (g_strcmp0 (_tmp17_, _tmp18_) == 0) {
		const gchar* _tmp19_ = NULL;
		const gchar* _tmp20_ = NULL;
		gchar* _tmp21_ = NULL;
		_tmp19_ = _result_;
		_tmp20_ = self->priv->_style;
		_tmp21_ = g_strdup_printf ("%s %s", _tmp19_, _tmp20_);
		_g_free0 (_result_);
		_result_ = _tmp21_;
	}
	result = _result_;
	_g_string_free0 (builder);
	return result;
}


FontConfigFont* font_config_font_construct (GType object_type) {
	FontConfigFont * self = NULL;
	self = (FontConfigFont*) cacheable_construct (object_type);
	return self;
}


FontConfigFont* font_config_font_new (void) {
	return font_config_font_construct (FONT_CONFIG_TYPE_FONT);
}


const gchar* font_config_font_get_filepath (FontConfigFont* self) {
	const gchar* result;
	const gchar* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_filepath;
	result = _tmp0_;
	return result;
}


void font_config_font_set_filepath (FontConfigFont* self, const gchar* value) {
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (self->priv->_filepath);
	self->priv->_filepath = _tmp1_;
	g_object_notify ((GObject *) self, "filepath");
}


gint font_config_font_get_index (FontConfigFont* self) {
	gint result;
	gint _tmp0_ = 0;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_index;
	result = _tmp0_;
	return result;
}


void font_config_font_set_index (FontConfigFont* self, gint value) {
	gint _tmp0_ = 0;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_index = _tmp0_;
	g_object_notify ((GObject *) self, "index");
}


const gchar* font_config_font_get_family (FontConfigFont* self) {
	const gchar* result;
	const gchar* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_family;
	result = _tmp0_;
	return result;
}


void font_config_font_set_family (FontConfigFont* self, const gchar* value) {
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (self->priv->_family);
	self->priv->_family = _tmp1_;
	g_object_notify ((GObject *) self, "family");
}


const gchar* font_config_font_get_style (FontConfigFont* self) {
	const gchar* result;
	const gchar* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_style;
	result = _tmp0_;
	return result;
}


void font_config_font_set_style (FontConfigFont* self, const gchar* value) {
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (self->priv->_style);
	self->priv->_style = _tmp1_;
	g_object_notify ((GObject *) self, "style");
}


gint font_config_font_get_slant (FontConfigFont* self) {
	gint result;
	gint _tmp0_ = 0;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_slant;
	result = _tmp0_;
	return result;
}


void font_config_font_set_slant (FontConfigFont* self, gint value) {
	gint _tmp0_ = 0;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_slant = _tmp0_;
	g_object_notify ((GObject *) self, "slant");
}


gint font_config_font_get_weight (FontConfigFont* self) {
	gint result;
	gint _tmp0_ = 0;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_weight;
	result = _tmp0_;
	return result;
}


void font_config_font_set_weight (FontConfigFont* self, gint value) {
	gint _tmp0_ = 0;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_weight = _tmp0_;
	g_object_notify ((GObject *) self, "weight");
}


gint font_config_font_get_width (FontConfigFont* self) {
	gint result;
	gint _tmp0_ = 0;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_width;
	result = _tmp0_;
	return result;
}


void font_config_font_set_width (FontConfigFont* self, gint value) {
	gint _tmp0_ = 0;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_width = _tmp0_;
	g_object_notify ((GObject *) self, "width");
}


gint font_config_font_get_spacing (FontConfigFont* self) {
	gint result;
	gint _tmp0_ = 0;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_spacing;
	result = _tmp0_;
	return result;
}


void font_config_font_set_spacing (FontConfigFont* self, gint value) {
	gint _tmp0_ = 0;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_spacing = _tmp0_;
	g_object_notify ((GObject *) self, "spacing");
}


gint font_config_font_get_owner (FontConfigFont* self) {
	gint result;
	gint _tmp0_ = 0;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_owner;
	result = _tmp0_;
	return result;
}


void font_config_font_set_owner (FontConfigFont* self, gint value) {
	gint _tmp0_ = 0;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_owner = _tmp0_;
	g_object_notify ((GObject *) self, "owner");
}


const gchar* font_config_font_get_description (FontConfigFont* self) {
	const gchar* result;
	const gchar* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_description;
	result = _tmp0_;
	return result;
}


void font_config_font_set_description (FontConfigFont* self, const gchar* value) {
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (self->priv->_description);
	self->priv->_description = _tmp1_;
	g_object_notify ((GObject *) self, "description");
}


static void font_config_font_class_init (FontConfigFontClass * klass) {
	font_config_font_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (FontConfigFontPrivate));
	G_OBJECT_CLASS (klass)->get_property = _vala_font_config_font_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_font_config_font_set_property;
	G_OBJECT_CLASS (klass)->finalize = font_config_font_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_CONFIG_FONT_FILEPATH, g_param_spec_string ("filepath", "filepath", "filepath", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_CONFIG_FONT_INDEX, g_param_spec_int ("index", "index", "index", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_CONFIG_FONT_FAMILY, g_param_spec_string ("family", "family", "family", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_CONFIG_FONT_STYLE, g_param_spec_string ("style", "style", "style", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_CONFIG_FONT_SLANT, g_param_spec_int ("slant", "slant", "slant", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_CONFIG_FONT_WEIGHT, g_param_spec_int ("weight", "weight", "weight", G_MININT, G_MAXINT, 80, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_CONFIG_FONT_WIDTH, g_param_spec_int ("width", "width", "width", G_MININT, G_MAXINT, 100, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_CONFIG_FONT_SPACING, g_param_spec_int ("spacing", "spacing", "spacing", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_CONFIG_FONT_OWNER, g_param_spec_int ("owner", "owner", "owner", G_MININT, G_MAXINT, -1, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_CONFIG_FONT_DESCRIPTION, g_param_spec_string ("description", "description", "description", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
}


static void font_config_font_instance_init (FontConfigFont * self) {
	self->priv = FONT_CONFIG_FONT_GET_PRIVATE (self);
	self->priv->_filepath = NULL;
	self->priv->_index = 0;
	self->priv->_family = NULL;
	self->priv->_style = NULL;
	self->priv->_slant = 0;
	self->priv->_weight = 80;
	self->priv->_width = 100;
	self->priv->_spacing = 0;
	self->priv->_owner = -1;
	self->priv->_description = NULL;
}


static void font_config_font_finalize (GObject* obj) {
	FontConfigFont * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, FONT_CONFIG_TYPE_FONT, FontConfigFont);
	_g_free0 (self->priv->_filepath);
	_g_free0 (self->priv->_family);
	_g_free0 (self->priv->_style);
	_g_free0 (self->priv->_description);
	G_OBJECT_CLASS (font_config_font_parent_class)->finalize (obj);
}


GType font_config_font_get_type (void) {
	static volatile gsize font_config_font_type_id__volatile = 0;
	if (g_once_init_enter (&font_config_font_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (FontConfigFontClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) font_config_font_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (FontConfigFont), 0, (GInstanceInitFunc) font_config_font_instance_init, NULL };
		GType font_config_font_type_id;
		font_config_font_type_id = g_type_register_static (TYPE_CACHEABLE, "FontConfigFont", &g_define_type_info, 0);
		g_once_init_leave (&font_config_font_type_id__volatile, font_config_font_type_id);
	}
	return font_config_font_type_id__volatile;
}


static void _vala_font_config_font_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	FontConfigFont * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, FONT_CONFIG_TYPE_FONT, FontConfigFont);
	switch (property_id) {
		case FONT_CONFIG_FONT_FILEPATH:
		g_value_set_string (value, font_config_font_get_filepath (self));
		break;
		case FONT_CONFIG_FONT_INDEX:
		g_value_set_int (value, font_config_font_get_index (self));
		break;
		case FONT_CONFIG_FONT_FAMILY:
		g_value_set_string (value, font_config_font_get_family (self));
		break;
		case FONT_CONFIG_FONT_STYLE:
		g_value_set_string (value, font_config_font_get_style (self));
		break;
		case FONT_CONFIG_FONT_SLANT:
		g_value_set_int (value, font_config_font_get_slant (self));
		break;
		case FONT_CONFIG_FONT_WEIGHT:
		g_value_set_int (value, font_config_font_get_weight (self));
		break;
		case FONT_CONFIG_FONT_WIDTH:
		g_value_set_int (value, font_config_font_get_width (self));
		break;
		case FONT_CONFIG_FONT_SPACING:
		g_value_set_int (value, font_config_font_get_spacing (self));
		break;
		case FONT_CONFIG_FONT_OWNER:
		g_value_set_int (value, font_config_font_get_owner (self));
		break;
		case FONT_CONFIG_FONT_DESCRIPTION:
		g_value_set_string (value, font_config_font_get_description (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_font_config_font_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	FontConfigFont * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, FONT_CONFIG_TYPE_FONT, FontConfigFont);
	switch (property_id) {
		case FONT_CONFIG_FONT_FILEPATH:
		font_config_font_set_filepath (self, g_value_get_string (value));
		break;
		case FONT_CONFIG_FONT_INDEX:
		font_config_font_set_index (self, g_value_get_int (value));
		break;
		case FONT_CONFIG_FONT_FAMILY:
		font_config_font_set_family (self, g_value_get_string (value));
		break;
		case FONT_CONFIG_FONT_STYLE:
		font_config_font_set_style (self, g_value_get_string (value));
		break;
		case FONT_CONFIG_FONT_SLANT:
		font_config_font_set_slant (self, g_value_get_int (value));
		break;
		case FONT_CONFIG_FONT_WEIGHT:
		font_config_font_set_weight (self, g_value_get_int (value));
		break;
		case FONT_CONFIG_FONT_WIDTH:
		font_config_font_set_width (self, g_value_get_int (value));
		break;
		case FONT_CONFIG_FONT_SPACING:
		font_config_font_set_spacing (self, g_value_get_int (value));
		break;
		case FONT_CONFIG_FONT_OWNER:
		font_config_font_set_owner (self, g_value_get_int (value));
		break;
		case FONT_CONFIG_FONT_DESCRIPTION:
		font_config_font_set_description (self, g_value_get_string (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



