/* Sources.c generated by valac 0.30.0, the Vala compiler
 * generated from Sources.vala, do not modify */

/* Sources.vala
 *
 * Copyright (C) 2009 - 2015 Jerry Casiano
 *
 * This file is part of Font Manager.
 *
 * Font Manager is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Font Manager is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Font Manager.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Author:
 *        Jerry Casiano <JerryCasiano@gmail.com>
*/

#include <glib.h>
#include <glib-object.h>
#include <gee.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <glib/gstdio.h>
#include <libxml/parser.h>
#include <libxml/tree.h>
#include <libxml/xmlwriter.h>
#include <glib/gi18n-lib.h>


#define FONT_CONFIG_TYPE_SOURCES (font_config_sources_get_type ())
#define FONT_CONFIG_SOURCES(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FONT_CONFIG_TYPE_SOURCES, FontConfigSources))
#define FONT_CONFIG_SOURCES_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FONT_CONFIG_TYPE_SOURCES, FontConfigSourcesClass))
#define FONT_CONFIG_IS_SOURCES(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FONT_CONFIG_TYPE_SOURCES))
#define FONT_CONFIG_IS_SOURCES_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FONT_CONFIG_TYPE_SOURCES))
#define FONT_CONFIG_SOURCES_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FONT_CONFIG_TYPE_SOURCES, FontConfigSourcesClass))

typedef struct _FontConfigSources FontConfigSources;
typedef struct _FontConfigSourcesClass FontConfigSourcesClass;
typedef struct _FontConfigSourcesPrivate FontConfigSourcesPrivate;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define FONT_CONFIG_TYPE_FONT_SOURCE (font_config_font_source_get_type ())
#define FONT_CONFIG_FONT_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FONT_CONFIG_TYPE_FONT_SOURCE, FontConfigFontSource))
#define FONT_CONFIG_FONT_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FONT_CONFIG_TYPE_FONT_SOURCE, FontConfigFontSourceClass))
#define FONT_CONFIG_IS_FONT_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FONT_CONFIG_TYPE_FONT_SOURCE))
#define FONT_CONFIG_IS_FONT_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FONT_CONFIG_TYPE_FONT_SOURCE))
#define FONT_CONFIG_FONT_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FONT_CONFIG_TYPE_FONT_SOURCE, FontConfigFontSourceClass))

typedef struct _FontConfigFontSource FontConfigFontSource;
typedef struct _FontConfigFontSourceClass FontConfigFontSourceClass;

#define FONT_MANAGER_TYPE_DATABASE (font_manager_database_get_type ())
#define FONT_MANAGER_DATABASE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FONT_MANAGER_TYPE_DATABASE, FontManagerDatabase))
#define FONT_MANAGER_DATABASE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FONT_MANAGER_TYPE_DATABASE, FontManagerDatabaseClass))
#define FONT_MANAGER_IS_DATABASE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FONT_MANAGER_TYPE_DATABASE))
#define FONT_MANAGER_IS_DATABASE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FONT_MANAGER_TYPE_DATABASE))
#define FONT_MANAGER_DATABASE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FONT_MANAGER_TYPE_DATABASE, FontManagerDatabaseClass))

typedef struct _FontManagerDatabase FontManagerDatabase;
typedef struct _FontManagerDatabaseClass FontManagerDatabaseClass;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _xmlFreeTextWriter0(var) ((var == NULL) ? NULL : (var = (xmlFreeTextWriter (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _FontConfigSources {
	GeeHashSet parent_instance;
	FontConfigSourcesPrivate * priv;
};

struct _FontConfigSourcesClass {
	GeeHashSetClass parent_class;
};

struct _FontConfigSourcesPrivate {
	gchar* target_file;
	gchar* target_element;
	GFileMonitor** monitors;
	gint monitors_length1;
	gint _monitors_size_;
	GVolumeMonitor* volume_monitor;
};

typedef enum  {
	FONT_MANAGER_DATABASE_ERROR_ERROR,
	FONT_MANAGER_DATABASE_ERROR_BACKING,
	FONT_MANAGER_DATABASE_ERROR_MEMORY,
	FONT_MANAGER_DATABASE_ERROR_ABORT,
	FONT_MANAGER_DATABASE_ERROR_LIMITS,
	FONT_MANAGER_DATABASE_ERROR_TYPESPEC
} FontManagerDatabaseError;
#define FONT_MANAGER_DATABASE_ERROR font_manager_database_error_quark ()

static gpointer font_config_sources_parent_class = NULL;

GType font_config_sources_get_type (void) G_GNUC_CONST;
#define FONT_CONFIG_SOURCES_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), FONT_CONFIG_TYPE_SOURCES, FontConfigSourcesPrivate))
enum  {
	FONT_CONFIG_SOURCES_DUMMY_PROPERTY
};
gchar* font_config_sources_get_cache_file (void);
#define FONT_MANAGER_NAME "font-manager"
FontConfigSources* font_config_sources_new (void);
FontConfigSources* font_config_sources_construct (GType object_type);
GType font_config_font_source_get_type (void) G_GNUC_CONST;
static void __lambda42_ (FontConfigSources* self, GMount* m);
gboolean font_config_sources_contains (FontConfigSources* self, const gchar* path);
static void font_config_sources_change_detected (FontConfigSources* self, GFile* file, GFile* other_file, GFileMonitorEvent event);
static void ___lambda42__g_volume_monitor_mount_removed (GVolumeMonitor* _sender, GMount* mount, gpointer self);
const gchar* font_config_font_source_get_path (FontConfigFontSource* self);
void font_config_sources_update (FontConfigSources* self);
void font_config_font_source_update (FontConfigFontSource* self);
gboolean font_config_sources_add (FontConfigSources* self, FontConfigFontSource* source);
static void __lambda46_ (FontConfigSources* self);
static void ___lambda46__g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self);
gboolean font_config_sources_remove (FontConfigSources* self, FontConfigFontSource* source);
void font_config_font_source_set_available (FontConfigFontSource* self, gboolean value);
GType font_manager_database_get_type (void) G_GNUC_CONST;
GQuark font_manager_database_error_quark (void);
FontManagerDatabase* font_manager_get_database (GError** error);
void font_manager_database_set_table (FontManagerDatabase* self, const gchar* value);
void font_manager_database_remove (FontManagerDatabase* self, const gchar* condition, GError** error);
void font_manager_database_vacuum (FontManagerDatabase* self, GError** error);
void font_manager_database_close (FontManagerDatabase* self);
void font_config_sources_cancel_monitors (FontConfigSources* self);
void font_config_sources_enable_monitors (FontConfigSources* self);
GeeArrayList* font_config_list_dirs (gboolean recursive);
static GFileMonitor* font_config_sources_get_directory_monitor (FontConfigSources* self, const gchar* dir);
static void _vala_array_add2 (GFileMonitor*** array, int* length, int* size, GFileMonitor* value);
static void _vala_array_add3 (GFileMonitor*** array, int* length, int* size, GFileMonitor* value);
static void ___lambda45_ (FontConfigSources* self, GFile* f, GFile* of, GFileMonitorEvent ev);
static void ____lambda45__g_file_monitor_changed (GFileMonitor* _sender, GFile* file, GFile* other_file, GFileMonitorEvent event_type, gpointer self);
gboolean font_config_sources_init (FontConfigSources* self);
void font_config_sources_parse (FontConfigSources* self, xmlNode* root);
void font_config_sources_save (FontConfigSources* self);
void font_config_sources_write_node (FontConfigSources* self, xmlTextWriter* writer);
void font_config_sources_parse_node (FontConfigSources* self, xmlNode* node);
FontConfigFontSource* font_config_font_source_new (GFile* file);
FontConfigFontSource* font_config_font_source_construct (GType object_type, GFile* file);
static void ______lambda44_ (FontConfigSources* self);
static void _______lambda44__g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self);
static void g_cclosure_user_marshal_VOID__OBJECT_ENUM (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
static void font_config_sources_finalize (GObject* obj);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);


gchar* font_config_sources_get_cache_file (void) {
	gchar* result = NULL;
	gchar* dirpath = NULL;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	gchar* filepath = NULL;
	gchar* _tmp2_ = NULL;
	_tmp0_ = g_get_user_config_dir ();
	_tmp1_ = g_build_filename (_tmp0_, FONT_MANAGER_NAME, NULL);
	dirpath = _tmp1_;
	_tmp2_ = g_build_filename (dirpath, "Sources.xml", NULL);
	filepath = _tmp2_;
	g_mkdir_with_parents (dirpath, 0755);
	result = filepath;
	_g_free0 (dirpath);
	return result;
}


static void __lambda42_ (FontConfigSources* self, GMount* m) {
	GMount* _tmp0_ = NULL;
	GFile* _tmp1_ = NULL;
	GFile* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp6_ = FALSE;
	g_return_if_fail (m != NULL);
	_tmp0_ = m;
	_tmp1_ = g_mount_get_default_location (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = g_file_get_path (_tmp2_);
	_tmp4_ = _tmp3_;
	_tmp5_ = font_config_sources_contains (self, _tmp4_);
	_tmp6_ = _tmp5_;
	_g_free0 (_tmp4_);
	_g_object_unref0 (_tmp2_);
	if (_tmp6_) {
		font_config_sources_change_detected (self, NULL, NULL, G_FILE_MONITOR_EVENT_CHANGED);
	}
}


static void ___lambda42__g_volume_monitor_mount_removed (GVolumeMonitor* _sender, GMount* mount, gpointer self) {
	__lambda42_ ((FontConfigSources*) self, mount);
}


FontConfigSources* font_config_sources_construct (GType object_type) {
	FontConfigSources * self = NULL;
	gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	GVolumeMonitor* _tmp2_ = NULL;
	GVolumeMonitor* _tmp3_ = NULL;
	self = (FontConfigSources*) gee_hash_set_construct (object_type, FONT_CONFIG_TYPE_FONT_SOURCE, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL);
	_tmp0_ = g_strdup ("source");
	_g_free0 (self->priv->target_element);
	self->priv->target_element = _tmp0_;
	_tmp1_ = font_config_sources_get_cache_file ();
	_g_free0 (self->priv->target_file);
	self->priv->target_file = _tmp1_;
	_tmp2_ = g_volume_monitor_get ();
	_g_object_unref0 (self->priv->volume_monitor);
	self->priv->volume_monitor = _tmp2_;
	_tmp3_ = self->priv->volume_monitor;
	g_signal_connect_object (_tmp3_, "mount-removed", (GCallback) ___lambda42__g_volume_monitor_mount_removed, self, 0);
	return self;
}


FontConfigSources* font_config_sources_new (void) {
	return font_config_sources_construct (FONT_CONFIG_TYPE_SOURCES);
}


static gboolean string_contains (const gchar* self, const gchar* needle) {
	gboolean result = FALSE;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (needle != NULL, FALSE);
	_tmp0_ = needle;
	_tmp1_ = strstr ((gchar*) self, (gchar*) _tmp0_);
	result = _tmp1_ != NULL;
	return result;
}


gboolean font_config_sources_contains (FontConfigSources* self, const gchar* path) {
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (path != NULL, FALSE);
	{
		GeeIterator* _source_it = NULL;
		GeeIterator* _tmp0_ = NULL;
		_tmp0_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) self);
		_source_it = _tmp0_;
		while (TRUE) {
			GeeIterator* _tmp1_ = NULL;
			gboolean _tmp2_ = FALSE;
			FontConfigFontSource* source = NULL;
			GeeIterator* _tmp3_ = NULL;
			gpointer _tmp4_ = NULL;
			FontConfigFontSource* _tmp5_ = NULL;
			const gchar* _tmp6_ = NULL;
			const gchar* _tmp7_ = NULL;
			const gchar* _tmp8_ = NULL;
			gboolean _tmp9_ = FALSE;
			_tmp1_ = _source_it;
			_tmp2_ = gee_iterator_next (_tmp1_);
			if (!_tmp2_) {
				break;
			}
			_tmp3_ = _source_it;
			_tmp4_ = gee_iterator_get (_tmp3_);
			source = (FontConfigFontSource*) _tmp4_;
			_tmp5_ = source;
			_tmp6_ = font_config_font_source_get_path (_tmp5_);
			_tmp7_ = _tmp6_;
			_tmp8_ = path;
			_tmp9_ = string_contains (_tmp7_, _tmp8_);
			if (_tmp9_) {
				result = TRUE;
				_g_object_unref0 (source);
				_g_object_unref0 (_source_it);
				return result;
			}
			_g_object_unref0 (source);
		}
		_g_object_unref0 (_source_it);
	}
	result = FALSE;
	return result;
}


void font_config_sources_update (FontConfigSources* self) {
	g_return_if_fail (self != NULL);
	{
		GeeIterator* _source_it = NULL;
		GeeIterator* _tmp0_ = NULL;
		_tmp0_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) self);
		_source_it = _tmp0_;
		while (TRUE) {
			GeeIterator* _tmp1_ = NULL;
			gboolean _tmp2_ = FALSE;
			FontConfigFontSource* source = NULL;
			GeeIterator* _tmp3_ = NULL;
			gpointer _tmp4_ = NULL;
			FontConfigFontSource* _tmp5_ = NULL;
			_tmp1_ = _source_it;
			_tmp2_ = gee_iterator_next (_tmp1_);
			if (!_tmp2_) {
				break;
			}
			_tmp3_ = _source_it;
			_tmp4_ = gee_iterator_get (_tmp3_);
			source = (FontConfigFontSource*) _tmp4_;
			_tmp5_ = source;
			font_config_font_source_update (_tmp5_);
			_g_object_unref0 (source);
		}
		_g_object_unref0 (_source_it);
	}
	return;
}


static void __lambda46_ (FontConfigSources* self) {
	font_config_sources_change_detected (self, NULL, NULL, G_FILE_MONITOR_EVENT_CHANGED);
}


static void ___lambda46__g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self) {
	__lambda46_ ((FontConfigSources*) self);
}


gboolean font_config_sources_add (FontConfigSources* self, FontConfigFontSource* source) {
	gboolean result = FALSE;
	FontConfigFontSource* _tmp0_ = NULL;
	FontConfigFontSource* _tmp1_ = NULL;
	gboolean _tmp2_ = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (source != NULL, FALSE);
	_tmp0_ = source;
	g_signal_connect_object ((GObject*) _tmp0_, "notify::active", (GCallback) ___lambda46__g_object_notify, self, 0);
	font_config_sources_change_detected (self, NULL, NULL, G_FILE_MONITOR_EVENT_CHANGED);
	_tmp1_ = source;
	_tmp2_ = GEE_ABSTRACT_COLLECTION_CLASS (font_config_sources_parent_class)->add ((GeeAbstractCollection*) G_TYPE_CHECK_INSTANCE_CAST (self, GEE_TYPE_HASH_SET, GeeHashSet), _tmp1_);
	result = _tmp2_;
	return result;
}


gboolean font_config_sources_remove (FontConfigSources* self, FontConfigFontSource* source) {
	gboolean result = FALSE;
	FontConfigFontSource* _tmp0_ = NULL;
	FontConfigFontSource* _tmp13_ = NULL;
	gboolean _tmp14_ = FALSE;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (source != NULL, FALSE);
	_tmp0_ = source;
	font_config_font_source_set_available (_tmp0_, FALSE);
	{
		FontManagerDatabase* db = NULL;
		FontManagerDatabase* _tmp1_ = NULL;
		FontManagerDatabase* _tmp2_ = NULL;
		FontManagerDatabase* _tmp3_ = NULL;
		FontConfigFontSource* _tmp4_ = NULL;
		const gchar* _tmp5_ = NULL;
		const gchar* _tmp6_ = NULL;
		gchar* _tmp7_ = NULL;
		gchar* _tmp8_ = NULL;
		FontManagerDatabase* _tmp9_ = NULL;
		FontManagerDatabase* _tmp10_ = NULL;
		_tmp1_ = font_manager_get_database (&_inner_error_);
		db = _tmp1_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			if (_inner_error_->domain == FONT_MANAGER_DATABASE_ERROR) {
				goto __catch38_font_manager_database_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return FALSE;
		}
		_tmp2_ = db;
		font_manager_database_set_table (_tmp2_, "Fonts");
		_tmp3_ = db;
		_tmp4_ = source;
		_tmp5_ = font_config_font_source_get_path (_tmp4_);
		_tmp6_ = _tmp5_;
		_tmp7_ = g_strdup_printf ("filepath LIKE \"%s%\"", _tmp6_);
		_tmp8_ = _tmp7_;
		font_manager_database_remove (_tmp3_, _tmp8_, &_inner_error_);
		_g_free0 (_tmp8_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			_g_object_unref0 (db);
			if (_inner_error_->domain == FONT_MANAGER_DATABASE_ERROR) {
				goto __catch38_font_manager_database_error;
			}
			_g_object_unref0 (db);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return FALSE;
		}
		_tmp9_ = db;
		font_manager_database_vacuum (_tmp9_, &_inner_error_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			_g_object_unref0 (db);
			if (_inner_error_->domain == FONT_MANAGER_DATABASE_ERROR) {
				goto __catch38_font_manager_database_error;
			}
			_g_object_unref0 (db);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return FALSE;
		}
		_tmp10_ = db;
		font_manager_database_close (_tmp10_);
		_g_object_unref0 (db);
	}
	goto __finally38;
	__catch38_font_manager_database_error:
	{
		GError* e = NULL;
		GError* _tmp11_ = NULL;
		const gchar* _tmp12_ = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp11_ = e;
		_tmp12_ = _tmp11_->message;
		g_warning ("Sources.vala:80: %s", _tmp12_);
		_g_error_free0 (e);
	}
	__finally38:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return FALSE;
	}
	_tmp13_ = source;
	_tmp14_ = GEE_ABSTRACT_COLLECTION_CLASS (font_config_sources_parent_class)->remove ((GeeAbstractCollection*) G_TYPE_CHECK_INSTANCE_CAST (self, GEE_TYPE_HASH_SET, GeeHashSet), _tmp13_);
	if (_tmp14_) {
		font_config_sources_change_detected (self, NULL, NULL, G_FILE_MONITOR_EVENT_CHANGED);
		result = TRUE;
		return result;
	}
	result = FALSE;
	return result;
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


void font_config_sources_cancel_monitors (FontConfigSources* self) {
	GFileMonitor** _tmp0_ = NULL;
	gint _tmp0__length1 = 0;
	GFileMonitor** _tmp4_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->monitors;
	_tmp0__length1 = self->priv->monitors_length1;
	{
		GFileMonitor** mon_collection = NULL;
		gint mon_collection_length1 = 0;
		gint _mon_collection_size_ = 0;
		gint mon_it = 0;
		mon_collection = _tmp0_;
		mon_collection_length1 = _tmp0__length1;
		for (mon_it = 0; mon_it < _tmp0__length1; mon_it = mon_it + 1) {
			GFileMonitor* _tmp1_ = NULL;
			GFileMonitor* mon = NULL;
			_tmp1_ = _g_object_ref0 (mon_collection[mon_it]);
			mon = _tmp1_;
			{
				GFileMonitor* _tmp2_ = NULL;
				_tmp2_ = mon;
				if (_tmp2_ != NULL) {
					GFileMonitor* _tmp3_ = NULL;
					_tmp3_ = mon;
					g_file_monitor_cancel (_tmp3_);
				}
				_g_object_unref0 (mon);
				mon = NULL;
				_g_object_unref0 (mon);
			}
		}
	}
	_tmp4_ = g_new0 (GFileMonitor*, 0 + 1);
	self->priv->monitors = (_vala_array_free (self->priv->monitors, self->priv->monitors_length1, (GDestroyNotify) g_object_unref), NULL);
	self->priv->monitors = _tmp4_;
	self->priv->monitors_length1 = 0;
	self->priv->_monitors_size_ = self->priv->monitors_length1;
	return;
}


static void _vala_array_add2 (GFileMonitor*** array, int* length, int* size, GFileMonitor* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (GFileMonitor*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}


static void _vala_array_add3 (GFileMonitor*** array, int* length, int* size, GFileMonitor* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (GFileMonitor*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}


void font_config_sources_enable_monitors (FontConfigSources* self) {
	GeeArrayList* _dirs = NULL;
	GeeArrayList* _tmp0_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = font_config_list_dirs (TRUE);
	_dirs = _tmp0_;
	{
		GeeArrayList* _dir_list = NULL;
		GeeArrayList* _tmp1_ = NULL;
		GeeArrayList* _tmp2_ = NULL;
		gint _dir_size = 0;
		GeeArrayList* _tmp3_ = NULL;
		gint _tmp4_ = 0;
		gint _tmp5_ = 0;
		gint _dir_index = 0;
		_tmp1_ = _dirs;
		_tmp2_ = _g_object_ref0 (_tmp1_);
		_dir_list = _tmp2_;
		_tmp3_ = _dir_list;
		_tmp4_ = gee_abstract_collection_get_size ((GeeCollection*) _tmp3_);
		_tmp5_ = _tmp4_;
		_dir_size = _tmp5_;
		_dir_index = -1;
		while (TRUE) {
			gint _tmp6_ = 0;
			gint _tmp7_ = 0;
			gint _tmp8_ = 0;
			gchar* dir = NULL;
			GeeArrayList* _tmp9_ = NULL;
			gint _tmp10_ = 0;
			gpointer _tmp11_ = NULL;
			GFileMonitor** _tmp12_ = NULL;
			gint _tmp12__length1 = 0;
			const gchar* _tmp13_ = NULL;
			GFileMonitor* _tmp14_ = NULL;
			_tmp6_ = _dir_index;
			_dir_index = _tmp6_ + 1;
			_tmp7_ = _dir_index;
			_tmp8_ = _dir_size;
			if (!(_tmp7_ < _tmp8_)) {
				break;
			}
			_tmp9_ = _dir_list;
			_tmp10_ = _dir_index;
			_tmp11_ = gee_abstract_list_get ((GeeAbstractList*) _tmp9_, _tmp10_);
			dir = (gchar*) _tmp11_;
			_tmp12_ = self->priv->monitors;
			_tmp12__length1 = self->priv->monitors_length1;
			_tmp13_ = dir;
			_tmp14_ = font_config_sources_get_directory_monitor (self, _tmp13_);
			_vala_array_add2 (&self->priv->monitors, &self->priv->monitors_length1, &self->priv->_monitors_size_, _tmp14_);
			_g_free0 (dir);
		}
		_g_object_unref0 (_dir_list);
	}
	{
		GeeIterator* _source_it = NULL;
		GeeIterator* _tmp15_ = NULL;
		_tmp15_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) self);
		_source_it = _tmp15_;
		while (TRUE) {
			GeeIterator* _tmp16_ = NULL;
			gboolean _tmp17_ = FALSE;
			FontConfigFontSource* source = NULL;
			GeeIterator* _tmp18_ = NULL;
			gpointer _tmp19_ = NULL;
			GeeArrayList* _tmp20_ = NULL;
			FontConfigFontSource* _tmp21_ = NULL;
			const gchar* _tmp22_ = NULL;
			const gchar* _tmp23_ = NULL;
			gboolean _tmp24_ = FALSE;
			_tmp16_ = _source_it;
			_tmp17_ = gee_iterator_next (_tmp16_);
			if (!_tmp17_) {
				break;
			}
			_tmp18_ = _source_it;
			_tmp19_ = gee_iterator_get (_tmp18_);
			source = (FontConfigFontSource*) _tmp19_;
			_tmp20_ = _dirs;
			_tmp21_ = source;
			_tmp22_ = font_config_font_source_get_path (_tmp21_);
			_tmp23_ = _tmp22_;
			_tmp24_ = gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp20_, _tmp23_);
			if (_tmp24_) {
				_g_object_unref0 (source);
				continue;
			} else {
				GFileMonitor** _tmp25_ = NULL;
				gint _tmp25__length1 = 0;
				FontConfigFontSource* _tmp26_ = NULL;
				const gchar* _tmp27_ = NULL;
				const gchar* _tmp28_ = NULL;
				GFileMonitor* _tmp29_ = NULL;
				_tmp25_ = self->priv->monitors;
				_tmp25__length1 = self->priv->monitors_length1;
				_tmp26_ = source;
				_tmp27_ = font_config_font_source_get_path (_tmp26_);
				_tmp28_ = _tmp27_;
				_tmp29_ = font_config_sources_get_directory_monitor (self, _tmp28_);
				_vala_array_add3 (&self->priv->monitors, &self->priv->monitors_length1, &self->priv->_monitors_size_, _tmp29_);
			}
			_g_object_unref0 (source);
		}
		_g_object_unref0 (_source_it);
	}
	_g_object_unref0 (_dirs);
	return;
}


static void font_config_sources_change_detected (FontConfigSources* self, GFile* file, GFile* other_file, GFileMonitorEvent event) {
	GFile* _tmp0_ = NULL;
	GFileMonitorEvent _tmp1_ = 0;
	g_return_if_fail (self != NULL);
	font_config_sources_cancel_monitors (self);
	_tmp0_ = file;
	_tmp1_ = event;
	g_signal_emit_by_name (self, "changed", _tmp0_, _tmp1_);
	return;
}


static void ___lambda45_ (FontConfigSources* self, GFile* f, GFile* of, GFileMonitorEvent ev) {
	GFile* _tmp0_ = NULL;
	GFile* _tmp1_ = NULL;
	GFileMonitorEvent _tmp2_ = 0;
	g_return_if_fail (f != NULL);
	_tmp0_ = f;
	_tmp1_ = of;
	_tmp2_ = ev;
	font_config_sources_change_detected (self, _tmp0_, _tmp1_, _tmp2_);
}


static void ____lambda45__g_file_monitor_changed (GFileMonitor* _sender, GFile* file, GFile* other_file, GFileMonitorEvent event_type, gpointer self) {
	___lambda45_ ((FontConfigSources*) self, file, other_file, event_type);
}


static GFileMonitor* font_config_sources_get_directory_monitor (FontConfigSources* self, const gchar* dir) {
	GFileMonitor* result = NULL;
	GFile* file = NULL;
	const gchar* _tmp0_ = NULL;
	GFile* _tmp1_ = NULL;
	GFileMonitor* monitor = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (dir != NULL, NULL);
	_tmp0_ = dir;
	_tmp1_ = g_file_new_for_path (_tmp0_);
	file = _tmp1_;
	monitor = NULL;
	{
		GFileMonitor* _tmp2_ = NULL;
		GFileMonitor* _tmp3_ = NULL;
		GFileMonitor* _tmp4_ = NULL;
		GFileMonitor* _tmp5_ = NULL;
		_tmp3_ = g_file_monitor_directory (file, G_FILE_MONITOR_NONE, NULL, &_inner_error_);
		_tmp2_ = _tmp3_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			if (_inner_error_->domain == G_IO_ERROR) {
				goto __catch39_g_io_error;
			}
			_g_object_unref0 (monitor);
			_g_object_unref0 (file);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		_tmp4_ = _tmp2_;
		_tmp2_ = NULL;
		_g_object_unref0 (monitor);
		monitor = _tmp4_;
		_tmp5_ = monitor;
		g_signal_connect_object (_tmp5_, "changed", (GCallback) ____lambda45__g_file_monitor_changed, self, 0);
		_g_object_unref0 (_tmp2_);
	}
	goto __finally39;
	__catch39_g_io_error:
	{
		GError* e = NULL;
		const gchar* _tmp6_ = NULL;
		GError* _tmp7_ = NULL;
		const gchar* _tmp8_ = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp6_ = dir;
		g_warning ("Sources.vala:128: Failed to create FileMonitor for %s", _tmp6_);
		_tmp7_ = e;
		_tmp8_ = _tmp7_->message;
		g_critical ("Sources.vala:129: FileMonitor creation failed : %s", _tmp8_);
		_g_error_free0 (e);
	}
	__finally39:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		_g_object_unref0 (monitor);
		_g_object_unref0 (file);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	result = monitor;
	_g_object_unref0 (file);
	return result;
}


gboolean font_config_sources_init (FontConfigSources* self) {
	gboolean result = FALSE;
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	xmlDoc* doc = NULL;
	const gchar* _tmp6_ = NULL;
	xmlDoc* _tmp7_ = NULL;
	xmlDoc* _tmp8_ = NULL;
	xmlNode* root = NULL;
	xmlDoc* _tmp9_ = NULL;
	xmlNode* _tmp10_ = NULL;
	xmlNode* _tmp11_ = NULL;
	xmlNode* _tmp13_ = NULL;
	xmlDoc* _tmp14_ = NULL;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->target_file;
	_tmp1_ = self->priv->target_element;
	_vala_return_val_if_fail ((_tmp0_ != NULL) && (_tmp1_ != NULL), "target_file != null && target_element != null", FALSE);
	{
		GFile* file = NULL;
		const gchar* _tmp2_ = NULL;
		GFile* _tmp3_ = NULL;
		GFile* _tmp4_ = NULL;
		gboolean _tmp5_ = FALSE;
		_tmp2_ = self->priv->target_file;
		_tmp3_ = g_file_new_for_path (_tmp2_);
		file = _tmp3_;
		_tmp4_ = file;
		_tmp5_ = g_file_query_exists (_tmp4_, NULL);
		if (!_tmp5_) {
			result = FALSE;
			_g_object_unref0 (file);
			return result;
		}
		_g_object_unref0 (file);
	}
	xmlInitParser ();
	_tmp6_ = self->priv->target_file;
	_tmp7_ = xmlParseFile (_tmp6_);
	doc = _tmp7_;
	_tmp8_ = doc;
	if (_tmp8_ == NULL) {
		xmlCleanupParser ();
		result = FALSE;
		return result;
	}
	_tmp9_ = doc;
	_tmp10_ = xmlDocGetRootElement (_tmp9_);
	root = _tmp10_;
	_tmp11_ = root;
	if (_tmp11_ == NULL) {
		xmlDoc* _tmp12_ = NULL;
		_tmp12_ = doc;
		xmlFreeDoc (_tmp12_);
		xmlCleanupParser ();
		result = FALSE;
		return result;
	}
	_tmp13_ = root;
	font_config_sources_parse (self, _tmp13_);
	_tmp14_ = doc;
	xmlFreeDoc (_tmp14_);
	xmlCleanupParser ();
	result = TRUE;
	return result;
}


void font_config_sources_save (FontConfigSources* self) {
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	xmlTextWriter* writer = NULL;
	const gchar* _tmp2_ = NULL;
	xmlTextWriter* _tmp3_ = NULL;
	const gchar* _tmp4_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->target_file;
	_tmp1_ = self->priv->target_element;
	_vala_return_if_fail ((_tmp0_ != NULL) && (_tmp1_ != NULL), "target_file != null && target_element != null");
	_tmp2_ = self->priv->target_file;
	_tmp3_ = xmlNewTextWriterFilename (_tmp2_, FALSE);
	writer = _tmp3_;
	xmlTextWriterSetIndent (writer, TRUE);
	xmlTextWriterSetIndentString (writer, (xmlChar*) "  ");
	xmlTextWriterStartDocument (writer, NULL, NULL, NULL);
	_tmp4_ = _ (" Generated by Font Manager. Do NOT edit this file. ");
	xmlTextWriterWriteComment (writer, (xmlChar*) _tmp4_);
	xmlTextWriterStartElement (writer, (xmlChar*) "Sources");
	font_config_sources_write_node (self, writer);
	xmlTextWriterEndElement (writer);
	xmlTextWriterEndDocument (writer);
	xmlTextWriterFlush (writer);
	_xmlFreeTextWriter0 (writer);
	return;
}


void font_config_sources_parse (FontConfigSources* self, xmlNode* root) {
	xmlNode* _tmp0_ = NULL;
	xmlNode* _tmp1_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = root;
	_tmp1_ = _tmp0_->children;
	font_config_sources_parse_node (self, _tmp1_);
}


static gchar* string_strip (const gchar* self) {
	gchar* result = NULL;
	gchar* _result_ = NULL;
	gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_strdup (self);
	_result_ = _tmp0_;
	_tmp1_ = _result_;
	g_strstrip (_tmp1_);
	result = _result_;
	return result;
}


void font_config_sources_write_node (FontConfigSources* self, xmlTextWriter* writer) {
	g_return_if_fail (self != NULL);
	g_return_if_fail (writer != NULL);
	{
		GeeIterator* _source_it = NULL;
		GeeIterator* _tmp0_ = NULL;
		_tmp0_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) self);
		_source_it = _tmp0_;
		while (TRUE) {
			GeeIterator* _tmp1_ = NULL;
			gboolean _tmp2_ = FALSE;
			FontConfigFontSource* source = NULL;
			GeeIterator* _tmp3_ = NULL;
			gpointer _tmp4_ = NULL;
			xmlTextWriter* _tmp5_ = NULL;
			const gchar* _tmp6_ = NULL;
			FontConfigFontSource* _tmp7_ = NULL;
			const gchar* _tmp8_ = NULL;
			const gchar* _tmp9_ = NULL;
			gchar* _tmp10_ = NULL;
			gchar* _tmp11_ = NULL;
			gchar* _tmp12_ = NULL;
			gchar* _tmp13_ = NULL;
			_tmp1_ = _source_it;
			_tmp2_ = gee_iterator_next (_tmp1_);
			if (!_tmp2_) {
				break;
			}
			_tmp3_ = _source_it;
			_tmp4_ = gee_iterator_get (_tmp3_);
			source = (FontConfigFontSource*) _tmp4_;
			_tmp5_ = writer;
			_tmp6_ = self->priv->target_element;
			_tmp7_ = source;
			_tmp8_ = font_config_font_source_get_path (_tmp7_);
			_tmp9_ = _tmp8_;
			_tmp10_ = string_strip (_tmp9_);
			_tmp11_ = _tmp10_;
			_tmp12_ = g_markup_escape_text (_tmp11_, (gssize) -1);
			_tmp13_ = _tmp12_;
			xmlTextWriterWriteElement (_tmp5_, (xmlChar*) _tmp6_, (xmlChar*) _tmp13_);
			_g_free0 (_tmp13_);
			_g_free0 (_tmp11_);
			_g_object_unref0 (source);
		}
		_g_object_unref0 (_source_it);
	}
	return;
}


static void ______lambda44_ (FontConfigSources* self) {
	font_config_sources_change_detected (self, NULL, NULL, G_FILE_MONITOR_EVENT_CHANGED);
}


static void _______lambda44__g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self) {
	______lambda44_ ((FontConfigSources*) self);
}


void font_config_sources_parse_node (FontConfigSources* self, xmlNode* node) {
	g_return_if_fail (self != NULL);
	{
		xmlNode* iter = NULL;
		xmlNode* _tmp0_ = NULL;
		_tmp0_ = node;
		iter = _tmp0_;
		{
			gboolean _tmp1_ = FALSE;
			_tmp1_ = TRUE;
			while (TRUE) {
				xmlNode* _tmp4_ = NULL;
				xmlNode* _tmp5_ = NULL;
				xmlElementType _tmp6_ = 0;
				gchar* content = NULL;
				xmlNode* _tmp7_ = NULL;
				gchar* _tmp8_ = NULL;
				const gchar* _tmp9_ = NULL;
				const gchar* _tmp10_ = NULL;
				gchar* _tmp11_ = NULL;
				const gchar* _tmp12_ = NULL;
				if (!_tmp1_) {
					xmlNode* _tmp2_ = NULL;
					xmlNode* _tmp3_ = NULL;
					_tmp2_ = iter;
					_tmp3_ = _tmp2_->next;
					iter = _tmp3_;
				}
				_tmp1_ = FALSE;
				_tmp4_ = iter;
				if (!(_tmp4_ != NULL)) {
					break;
				}
				_tmp5_ = iter;
				_tmp6_ = _tmp5_->type;
				if (_tmp6_ != XML_ELEMENT_NODE) {
					continue;
				}
				_tmp7_ = iter;
				_tmp8_ = (gchar*) xmlNodeGetContent (_tmp7_);
				content = _tmp8_;
				_tmp9_ = content;
				if (_tmp9_ == NULL) {
					_g_free0 (content);
					continue;
				}
				_tmp10_ = content;
				_tmp11_ = string_strip (_tmp10_);
				_g_free0 (content);
				content = _tmp11_;
				_tmp12_ = content;
				if (g_strcmp0 (_tmp12_, "") == 0) {
					_g_free0 (content);
					continue;
				} else {
					FontConfigFontSource* source = NULL;
					const gchar* _tmp13_ = NULL;
					GFile* _tmp14_ = NULL;
					GFile* _tmp15_ = NULL;
					FontConfigFontSource* _tmp16_ = NULL;
					FontConfigFontSource* _tmp17_ = NULL;
					FontConfigFontSource* _tmp18_ = NULL;
					FontConfigFontSource* _tmp19_ = NULL;
					_tmp13_ = content;
					_tmp14_ = g_file_new_for_path (_tmp13_);
					_tmp15_ = _tmp14_;
					_tmp16_ = font_config_font_source_new (_tmp15_);
					_tmp17_ = _tmp16_;
					_g_object_unref0 (_tmp15_);
					source = _tmp17_;
					_tmp18_ = source;
					g_signal_connect_object ((GObject*) _tmp18_, "notify::active", (GCallback) _______lambda44__g_object_notify, self, 0);
					_tmp19_ = source;
					GEE_ABSTRACT_COLLECTION_CLASS (font_config_sources_parent_class)->add ((GeeAbstractCollection*) G_TYPE_CHECK_INSTANCE_CAST (self, GEE_TYPE_HASH_SET, GeeHashSet), _tmp19_);
					_g_object_unref0 (source);
				}
				_g_free0 (content);
			}
		}
	}
	return;
}


static void g_cclosure_user_marshal_VOID__OBJECT_ENUM (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__OBJECT_ENUM) (gpointer data1, gpointer arg_1, gint arg_2, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_ENUM callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 3);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__OBJECT_ENUM) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_object (param_values + 1), g_value_get_enum (param_values + 2), data2);
}


static void font_config_sources_class_init (FontConfigSourcesClass * klass) {
	font_config_sources_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (FontConfigSourcesPrivate));
	G_OBJECT_CLASS (klass)->finalize = font_config_sources_finalize;
	g_signal_new ("changed", FONT_CONFIG_TYPE_SOURCES, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_ENUM, G_TYPE_NONE, 2, G_TYPE_FILE, g_file_monitor_event_get_type ());
}


static void font_config_sources_instance_init (FontConfigSources * self) {
	GFileMonitor** _tmp0_ = NULL;
	self->priv = FONT_CONFIG_SOURCES_GET_PRIVATE (self);
	self->priv->target_file = NULL;
	self->priv->target_element = NULL;
	_tmp0_ = g_new0 (GFileMonitor*, 0 + 1);
	self->priv->monitors = _tmp0_;
	self->priv->monitors_length1 = 0;
	self->priv->_monitors_size_ = self->priv->monitors_length1;
}


static void font_config_sources_finalize (GObject* obj) {
	FontConfigSources * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, FONT_CONFIG_TYPE_SOURCES, FontConfigSources);
	_g_free0 (self->priv->target_file);
	_g_free0 (self->priv->target_element);
	self->priv->monitors = (_vala_array_free (self->priv->monitors, self->priv->monitors_length1, (GDestroyNotify) g_object_unref), NULL);
	_g_object_unref0 (self->priv->volume_monitor);
	G_OBJECT_CLASS (font_config_sources_parent_class)->finalize (obj);
}


GType font_config_sources_get_type (void) {
	static volatile gsize font_config_sources_type_id__volatile = 0;
	if (g_once_init_enter (&font_config_sources_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (FontConfigSourcesClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) font_config_sources_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (FontConfigSources), 0, (GInstanceInitFunc) font_config_sources_instance_init, NULL };
		GType font_config_sources_type_id;
		font_config_sources_type_id = g_type_register_static (GEE_TYPE_HASH_SET, "FontConfigSources", &g_define_type_info, 0);
		g_once_init_leave (&font_config_sources_type_id__volatile, font_config_sources_type_id);
	}
	return font_config_sources_type_id__volatile;
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}



